' === Count2Digits2Tasks.bas ===================================
'
' Program runs on a 20M2 processor, and uses an LDD-N514RI-RA
' 2-digit, 7-segment LED display. The digits are multiplexed
' by two transistors (a 2N3906 [PNP], and a 2N3904 [NPN)],
' which are both connected to the A.0 (pseudo) output pin.

' The program uses two parallel tasks to count from 00 to 99,
	
' === Directives ====
  #com 6                 'specify com port
  #picaxe 20M2           'specify PICAXE processor
  #no_data               'save time downloading
  #terminal off          'disable the terminal window

' === Variables =====
  symbol   dig01 = b0    'one's digit of the count
  symbol   dig10 = b1    'ten's digit of the count
  symbol  segs01 = b2    'stores segment pattern for one's digit
  symbol  segs10 = b3    'stores segment pattern for ten's digit
  
' === Begin Main Program =======================================
start0:                  'Task 0 = update segment values
dirsB= %11111111         'two-digit LED display on portB
dirsC= %10111111         'pin C.6 is fixed as an input

do
  if time > 99 then      'avoid overflow in the time variable
    time = 0
  endif
  
  dig01 = time // 10     'get the one's digit 
  lookup dig01,(63,6,91,79,102,109,125,7,127,111),segs01
  
  dig10 = time /  10     'get the ten's digit  
  lookup dig10,(63,6,91,79,102,109,125,7,127,111),segs10
loop

start1:                  'Task 1 = multiplex the display
do
  pinsB = 0              'blank the display to avoid ghosting
  low A.0                'set up for one's digit
  pinsB = segs01         'display one's segments
  low A.0                'use in place of pause or pauseus
  low A.0                'to balance digit brightness
  pinsB = 0              'blank the display to avoid ghosting 
  high A.0               'set up for ten's digit
  pinsB = segs10         'display ten's segments
loop