' === Switch3Tasks.bas =============================
' This program demonstrates how easy it is to add an
' additional task in a parallel task program.

' === Directives ====
  #com 6              'specify com port
  #picaxe 08M2        'specify PICAXE processor
  #no_data            'save time downloading
  #terminal off       'disable the terminal window
  
' === Constants =====
  symbol LED0 = C.0   '"I'm alive" LED on C.0
  symbol LED2 = C.2   'another blinking LED on C.2
  symbol LED4 = C.4   'switched LED on C.4

' === Variables =====
  symbol index = b0   'for/next loop counter
  symbol sw3 = pinC.3 'momentary switch on C.3

' === Begin Main Program ===========================
start0:
  pinsC = %00010111   'C.5 & C.3 are fixed as inputs
  pullup  %00001000   'enable pullup on pin C.3

  do
    high LED0         'briefly blink the C.0 LED
    pause 100
    low  LED0
    pause 4900        'to total 5 seconds per blink
  loop

start1:
  do
    if sw3 = 1 then   'if switch is not pressed then
      low  LED4       'turn off the C.4 LED
    else              'else
      high LED4       'turn it on
    endif
  loop
  
start2:
  do
    high LED2         'briefly blink the C.2 LED          
    pause 100
    low  LED2
    pause 900         'to total 1 second per blink
  loop